"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AsModal = AsModal;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactstrap = require("reactstrap");

var _reactRouterDom = require("react-router-dom");

var _context = require("./context");

var _utils = require("./utils");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function AsModal(WrappedComponent) {
  var AsModal = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2.default)(AsModal, _React$Component);

    var _super = _createSuper(AsModal);

    function AsModal(props) {
      var _this;

      (0, _classCallCheck2.default)(this, AsModal);
      _this = _super.call(this, props);
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "path_match", function () {
        return _this.regex.test(_this.props.location.pathname);
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "parent_uri", function () {
        if (_this.props.parent_uri) {
          return _this.props.parent_uri;
        } else {
          return _this.props.location.pathname.replace(_this.regex, '');
        }
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "toggle", function () {
        return _this.setState({
          open: _this.path_match()
        });
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "close", function () {
        return _this.props.history.replace(_this.parent_uri());
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onSubmitWrapper", function (r) {
        _this.close();

        _this.props.onSubmit && _this.props.onSubmit(r);
      });
      _this.regex = props.regex || /modal\/$/;
      _this.state = {
        open: _this.path_match()
      };
      return _this;
    }

    (0, _createClass2.default)(AsModal, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.toggle();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        if (this.props.location.pathname !== prevProps.location.pathname) {
          this.toggle();
        }
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/_react.default.createElement(_reactstrap.Modal, {
          isOpen: this.state.open,
          toggle: this.close,
          size: this.props.size,
          className: this.props.className
        }, /*#__PURE__*/_react.default.createElement(_reactstrap.ModalHeader, {
          toggle: this.close
        }, this.props.title, /*#__PURE__*/_react.default.createElement("span", {
          id: "modal-title"
        })), /*#__PURE__*/_react.default.createElement(WrappedComponent, (0, _extends2.default)({}, this.props, {
          onCancel: this.close,
          onSubmit: this.onSubmitWrapper,
          modal_open: this.state.open,
          form_body_class: "modal-body",
          form_footer_class: "modal-footer"
        })));
      }
    }]);
    return AsModal;
  }(_react.default.Component);

  AsModal.displayName = "AsModal(".concat((0, _utils.get_component_name)(WrappedComponent), ")");
  return (0, _context.WithContext)((0, _reactRouterDom.withRouter)(AsModal));
}