"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.message_toast = message_toast;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactstrap = require("reactstrap");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _utils = require("./utils");

var _confirm = require("./confirm");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var ToastMessage = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(ToastMessage, _React$Component);

  var _super = _createSuper(ToastMessage);

  function ToastMessage() {
    var _this;

    (0, _classCallCheck2.default)(this, ToastMessage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      open: true,
      closing: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "v", 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "hover", false);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "progress_ref", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "run", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(v) {
        var step, steps, steps_remaining;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                step = 20;
                steps = _this.props.time / step;
                steps_remaining = steps;

              case 3:
                if (!(steps_remaining > 0)) {
                  _context.next = 12;
                  break;
                }

                if (!(v !== _this.v)) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("return");

              case 6:
                if (_this.progress_ref.current) {
                  _this.progress_ref.current.style.width = "".concat(steps_remaining / steps * 100, "%");
                }

                if (!_this.hover) {
                  steps_remaining -= 1;
                }

                _context.next = 10;
                return (0, _utils.sleep)(step);

              case 10:
                _context.next = 3;
                break;

              case 12:
                _context.next = 14;
                return _this._finish(v);

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "close", function () {
      _this.v += 1;

      _this._finish(_this.v);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "_finish", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(v) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this.setState({
                  closing: true
                });

                _context2.next = 3;
                return (0, _utils.sleep)(700);

              case 3:
                if (v === _this.v) {
                  _this.setState({
                    open: false,
                    closing: false
                  }, function () {
                    return _this.props.remove();
                  });
                }

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x2) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "set_hover", function (v) {
      _this.hover = v;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onClick", function (e) {
      if (_this.props.onClick) {
        e.close = function () {
          return _this.close();
        };

        _this.props.onClick(e);
      }
    });
    return _this;
  }

  (0, _createClass2.default)(ToastMessage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.run(this.v);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      if (!this.state.open) {
        return /*#__PURE__*/_react.default.createElement("div", null);
      }

      var classes = ['toast-msg'];
      this.state.closing && classes.push('t-closing');
      this.props.onClick && classes.push('cursor-pointer');
      this.props.className && classes.push(this.props.className);
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classes.join(' '),
        onClick: this.onClick
      }, /*#__PURE__*/_react.default.createElement(_reactstrap.Toast, {
        onMouseEnter: function onMouseEnter() {
          return _this2.set_hover(true);
        },
        onMouseLeave: function onMouseLeave() {
          return _this2.set_hover(false);
        }
      }, /*#__PURE__*/_react.default.createElement(_reactstrap.ToastHeader, {
        toggle: function toggle() {
          return _this2.close();
        }
      }, this.props.icon && /*#__PURE__*/_react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
        icon: this.props.icon,
        className: "mr-2"
      }), this.props.title), this.props.progress ? /*#__PURE__*/_react.default.createElement("div", {
        ref: this.progress_ref,
        className: "toast-progress"
      }) : null, /*#__PURE__*/_react.default.createElement(_reactstrap.ToastBody, null, this.props.message)));
    }
  }]);
  return ToastMessage;
}(_react.default.Component);

var ToastMessages = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2.default)(ToastMessages, _React$Component2);

  var _super2 = _createSuper(ToastMessages);

  function ToastMessages() {
    var _this3;

    (0, _classCallCheck2.default)(this, ToastMessages);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "state", {
      toasts: []
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "visible", 1);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "remove", function () {
      _this3.visible -= 1;

      if (_this3.visible === 0) {
        _this3.setState({
          toasts: []
        });
      }
    });
    return _this3;
  }

  (0, _createClass2.default)(ToastMessages, [{
    key: "componentDidMount",
    // number of visible toasts
    value: function componentDidMount() {
      var toasts = [this.props];
      this.setState({
        toasts: toasts
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.tkey !== prevProps.tkey) {
        var toasts = (0, _toConsumableArray2.default)(this.state.toasts);
        toasts.push(this.props);
        this.setState({
          toasts: toasts
        });
        this.visible += 1;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "toast-msgs"
      }, this.state.toasts.map(function (t) {
        return /*#__PURE__*/_react.default.createElement(ToastMessage, (0, _extends2.default)({}, t, {
          key: t.tkey,
          remove: _this4.remove
        }));
      }));
    }
  }]);
  return ToastMessages;
}(_react.default.Component);

var rand_int = function rand_int() {
  return Math.round(Math.random() * 100000);
};

function message_toast(_ref3) {
  var title = _ref3.title,
      message = _ref3.message,
      icon = _ref3.icon,
      onClick = _ref3.onClick,
      className = _ref3.className,
      _ref3$time = _ref3.time,
      time = _ref3$time === void 0 ? 5000 : _ref3$time,
      _ref3$progress = _ref3.progress,
      progress = _ref3$progress === void 0 ? true : _ref3$progress,
      _ref3$body = _ref3.body,
      body = _ref3$body === void 0 ? null : _ref3$body,
      _ref3$toast_icon = _ref3.toast_icon,
      toast_icon = _ref3$toast_icon === void 0 ? null : _ref3$toast_icon;
  message = message || body;
  icon = toast_icon || icon;

  if (typeof icon === 'string' && !/^fa/.test(icon)) {
    // happens when the icon was set in notify
    icon = null;
  }

  _reactDom.default.render( /*#__PURE__*/_react.default.createElement(ToastMessages, {
    title: title,
    message: message,
    icon: icon,
    onClick: onClick,
    className: className,
    time: time,
    progress: progress,
    tkey: rand_int()
  }), (0, _confirm.get_create_element)('rstb-message-toast'));
}