"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WithContext = WithContext;
exports.GlobalContext = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("./utils");

var GlobalContext = /*#__PURE__*/_react.default.createContext({});

exports.GlobalContext = GlobalContext;

function WithContext(WrappedComponent) {
  var WithContext = function WithContext(props) {
    return /*#__PURE__*/_react.default.createElement(GlobalContext.Consumer, null, function (ctx) {
      return /*#__PURE__*/_react.default.createElement(WrappedComponent, (0, _extends2.default)({}, props, {
        ctx: ctx
      }));
    });
  };

  WithContext.displayName = "WithContext(".concat((0, _utils.get_component_name)(WrappedComponent), ")");
  return WithContext;
}